
# test

A = [2 0 2];
B = [4 -2 1];
C = [0 2 2];

v1 = B - A
v2 = C - A

THETA = acos(dot(v1, v2) / (norm(v1) * norm(v2))) / 2
# rad2deg(THETA)

rotAxis = cross(v1, v2)

uRotAxis = rotAxis / norm(rotAxis)

WX = uRotAxis(1);
WY = uRotAxis(2);
WZ = uRotAxis(3);

MCOS = 1 - cos(THETA);
COSA = cos(THETA);
SINA = sin(THETA);

M11 = WX * WX * MCOS + COSA;
M12 = WX * WY * MCOS + WZ * SINA;
M13 = WX * WZ * MCOS - WY * SINA;

M21 = WY * WX * MCOS - WZ * SINA;
M22 = WY * WY * MCOS + COSA;
M23 = WY * WZ * MCOS + WX * SINA;

M31 = WZ * WX * MCOS + WY * SINA;
M32 = WZ * WY * MCOS - WX * SINA;
M33 = WZ * WZ * MCOS + COSA;

rotMatrix = [M11 M12 M13; M21 M22 M23; M31 M32 M33]'
aDirect = rotMatrix * v1'

u = aDirect / norm(aDirect)

if (norm(C - A) > norm(B - A))
  LT = norm(C - A)
else
  LT = norm(B - A)
endif

ut = u' * LT
D = A + ut
